/**
  *  \file planetscentral/console/context.h
  *  \brief Console: Context Handling
  */
#ifndef C2SERVER_PLANETSCENTRAL_CONSOLE_CONTEXT_H
#define C2SERVER_PLANETSCENTRAL_CONSOLE_CONTEXT_H

#include "cpluslib/string.h"
#include "planetscentral/dbclient/connection.h"
#include "planetscentral/dbclient/dbclient.h"

/** Command context. */
class Context {
 public:
    Context()
        { }
    virtual ~Context()
        { }
    virtual void enter() = 0;
    virtual void leave() = 0;
    virtual IntValue* processCommand(StringList_t& cmd) = 0;
    virtual string_t getPrefix() = 0;
};

/** Command context for an application server connection. */
class ConnectionContext : public Context {
 public:
    ConnectionContext(string_t name);
    void enter();
    void leave();
    IntValue* processCommand(StringList_t& cmd);
    string_t getPrefix();

    bool checkConfig(string_t prefix, string_t key, string_t value);

 private:
    string_t name;
    string_t host;
    string_t port;
    DbClient client;
};

#endif
